SystemOrganization addCategory: #'Irka-Core'!
SystemOrganization addCategory: #'Irka-GUI'!
SystemOrganization addCategory: #'Irka-Test'!

StandardWindow subclass: #IrkaBrowser
	instanceVariableNames: 'typingBox serverList activeServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaBrowser methodsFor: 'connecting' stamp: 'AttilaMagyar 11/5/2012 22:50'!
buildUI
	| bottomPane topPane serverPanel |
	self title: 'Irka browser'.	
	activeServer := IrkaServer new.
	bottomPane := IrkaPanels verticalPane.
	topPane := IrkaPanels horizontalPane.
	typingBox := IrkaTypingBox 
						on: activeServer
						entered: #messageToActiveChan:.
	
	serverPanel := IrkaPanels verticalPane.					
	serverList := IrkaServerList new.
	serverPanel 
		addMorph: (self button: 'Connect' action: #connect);
		addMorph: serverList.		
	topPane
		addMorph: activeServer nickLists;
		addMorph: activeServer chanList;
		addMorph: serverPanel.
	bottomPane 
		addMorph: typingBox;
		addMorph: activeServer chanMessages.
	self 
		addMorph: topPane frame: (0@0 corner: 1@0.3);
		addMorph: bottomPane frame: (0@0.3 corner: 1@1)! !

!IrkaBrowser methodsFor: 'private' stamp: 'AttilaMagyar 11/5/2012 22:51'!
button: btnLabelString action: aSymbol
	| button |
	button := PluggableButtonMorph
		on: self 
		getState: nil 
		action: aSymbol.		
	button 
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		label: btnLabelString.
	^ button! !

!IrkaBrowser methodsFor: 'private' stamp: 'AttilaMagyar 11/5/2012 22:45'!
closeBoxHit
	super closeBoxHit.
	activeServer disconnect.! !

!IrkaBrowser methodsFor: 'user actions' stamp: 'AttilaMagyar 11/5/2012 22:56'!
connect
	| serverHost |
	serverHost := UIManager default 
		request: 'Server host:' 
		initialAnswer: 'irc.freenode.net'.
	serverHost 
		ifNotNil: 
			[ activeServer disconnect.
			self connectTo: serverHost port: 6667 ].! !

!IrkaBrowser methodsFor: 'initialization' stamp: 'AttilaMagyar 11/5/2012 22:44'!
connectTo: hostString port: portNumber
	activeServer
		connectTo: hostString 
		port: portNumber.
	serverList addServer: hostString.! !

!IrkaBrowser methodsFor: 'connecting' stamp: 'AttilaMagyar 11/5/2012 22:44'!
initialize
	super initialize.	
	self buildUI.! !

!String methodsFor: '*irka' stamp: 'AttilaMagyar 9/25/2012 14:36'!
hasIrcPrefix
	^ self beginsWith: ':'! !

!String methodsFor: '*irka' stamp: 'AttilaMagyar 9/25/2012 14:37'!
withoutIrcPrefix
	^ (self beginsWith: ':') ifTrue: [ self allButFirst: 1 ] ifFalse: [ self ]! !

PanelMorph subclass: #IrkaCardDeck
	instanceVariableNames: 'deck'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaCardDeck methodsFor: 'private' stamp: 'AttilaMagyar 11/1/2012 23:50'!
addCardFront: aMorph
	self clearFrontCard.
	self addMorph: aMorph.! !

!IrkaCardDeck methodsFor: 'user interface' stamp: 'AttilaMagyar 11/2/2012 20:52'!
at: keyObject ifAbsentPutCard: aBlock
	^ deck 
			at: keyObject 
			ifAbsentPut: [ aBlock value ] .! !

!IrkaCardDeck methodsFor: 'user interface' stamp: 'AttilaMagyar 11/1/2012 23:22'!
at: keyObject putCard: aMorph
	^ deck at: keyObject put: aMorph ! !

!IrkaCardDeck methodsFor: 'user interface' stamp: 'AttilaMagyar 11/2/2012 22:14'!
cardAt: keyObject
	^ deck at: keyObject ! !

!IrkaCardDeck methodsFor: 'private' stamp: 'AttilaMagyar 11/1/2012 23:49'!
clearFrontCard
	self removeAllMorphs.! !

!IrkaCardDeck methodsFor: 'user interface' stamp: 'AttilaMagyar 11/2/2012 21:38'!
hasCard: aKeyObject
	^ deck includesKey: aKeyObject 
	! !

!IrkaCardDeck methodsFor: 'initialization' stamp: 'AttilaMagyar 11/1/2012 23:21'!
initialize 
	super initialize.
	deck := Dictionary new.! !

!IrkaCardDeck methodsFor: 'private' stamp: 'AttilaMagyar 11/1/2012 23:39'!
isFrontCard: aMorph
	^ self allMorphs includes: aMorph! !

!IrkaCardDeck methodsFor: 'user interface' stamp: 'AttilaMagyar 11/2/2012 20:51'!
pickCardAt: aKeyObject
	| card |
	card := deck at: aKeyObject.
	self addCardFront: card.
	^ card.! !

!IrkaCardDeck methodsFor: 'user interface' stamp: 'AttilaMagyar 11/1/2012 23:50'!
removeCardFrom: aKeyObject
	| cardToBeRemoved |
	cardToBeRemoved := deck removeKey: aKeyObject.
	(self isFrontCard: cardToBeRemoved)
		ifTrue: 
			[ deck values 
				ifEmpty: 
					[ self clearFrontCard ] 
				ifNotEmpty: 
					[ self addCardFront: deck values first ] ]! !

IrkaCardDeck subclass: #IrkaChanMessages
	instanceVariableNames: 'channels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaChanMessages methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/1/2012 18:15'!
initialize 
	super initialize.
	self
		layoutPolicy: TableLayout new;
		hResizing: #spaceFill;
		vResizing: #spaceFill.	
	channels := Dictionary new.! !

!IrkaChanMessages methodsFor: 'events' stamp: 'AttilaMagyar 11/2/2012 22:14'!
messageReceived: anIrkaMessage
	| messagesArea |	
	messagesArea := self cardAt: anIrkaMessage chan.
	messagesArea addMessage: '[' , anIrkaMessage user nick , '] ' , anIrkaMessage message! !

!IrkaChanMessages methodsFor: 'switching' stamp: 'AttilaMagyar 11/3/2012 19:53'!
removeChanMessage: anIrkaChannel
	self removeCardFrom: anIrkaChannel ! !

!IrkaChanMessages methodsFor: 'switching' stamp: 'AttilaMagyar 11/2/2012 20:54'!
switchToChan: anIrkaChannel
	self	
		at: anIrkaChannel 
		ifAbsentPutCard: [ IrkaMessagesMorph new ].
	self pickCardAt: anIrkaChannel.! !

!IrkaChanMessages methodsFor: 'events' stamp: 'AttilaMagyar 11/4/2012 20:41'!
systemNotification: aString onChan: anIrkaChannel 
	| messagesArea |	
	messagesArea := self cardAt: anIrkaChannel.
	messagesArea addMessage: aString.! !

IrkaCardDeck subclass: #IrkaNickLists
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaNickLists methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/2/2012 21:38'!
addNick: aString toChan: anIrkaChannel
	| nickList |
	nickList := self at: anIrkaChannel ifAbsentPutCard: [ IrkaNickList new ].
	nickList addNick: aString.
	(self hasCard: self uninitializedKey)
		ifTrue: 
			[ self removeCardFrom: self uninitializedKey.
			self pickCardAt: anIrkaChannel ].! !

!IrkaNickLists methodsFor: 'initialization' stamp: 'AttilaMagyar 11/2/2012 21:37'!
initialize 
	super initialize.
	self
		layoutPolicy: TableLayout new;
		hResizing: #spaceFill;
		vResizing: #spaceFill.	
	self 
		at: self uninitializedKey
		putCard: IrkaNickList new.
	self pickCardAt: self uninitializedKey.! !

!IrkaNickLists methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/3/2012 19:54'!
removeChanNickList: anIrkaChannel
	self removeCardFrom: anIrkaChannel ! !

!IrkaNickLists methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/3/2012 18:58'!
removeNick: aString fromChan: anIrkaChannel
	| nickList |
	nickList := self cardAt: anIrkaChannel.
	nickList removeNick: aString.! !

!IrkaNickLists methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/10/2012 00:08'!
renameNick: fromString to: toString atChan: anIrkaChannel
	self 
		removeNick: fromString 
		fromChan: anIrkaChannel.
	self 
		addNick: toString 
		toChan: anIrkaChannel.! !

!IrkaNickLists methodsFor: 'switching' stamp: 'AttilaMagyar 11/4/2012 20:38'!
switchToChan: anIrkaChannel
	self 
		at: anIrkaChannel 
		ifAbsentPutCard: IrkaNickList new.
	self pickCardAt: anIrkaChannel.! !

!IrkaNickLists methodsFor: 'private' stamp: 'AttilaMagyar 11/2/2012 21:37'!
uninitializedKey
	^ 'uninitialized'! !

PanelMorph subclass: #IrkaChanList
	instanceVariableNames: 'chans announcer chanListMorph session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaChanList methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/4/2012 22:16'!
addChan: anIrkaChannel
	chans add: anIrkaChannel.
	self changed: #list.! !

!IrkaChanList methodsFor: 'accessing' stamp: 'AttilaMagyar 11/2/2012 21:55'!
announcer
	^ announcer! !

!IrkaChanList methodsFor: 'private' stamp: 'AttilaMagyar 11/5/2012 21:45'!
button: labelString action: aSymbol
	| button |
	button := PluggableButtonMorph
		on: self 
		getState: nil 
		action: aSymbol.		
	button 
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		label: labelString.
	^ button! !

!IrkaChanList methodsFor: 'private' stamp: 'AttilaMagyar 11/5/2012 21:40'!
createChanList
	^ (PluggableListMorph
		on: self
		list: #list
		selected: #index
		changeSelected: #index:
		menu: #menu)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself.! !

!IrkaChanList methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/4/2012 22:22'!
firstChan
	^ chans list first! !

!IrkaChanList methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/4/2012 22:23'!
hasChan
	^ chans list notEmpty ! !

!IrkaChanList methodsFor: 'model' stamp: 'AttilaMagyar 11/2/2012 21:58'!
index
	^ chans index! !

!IrkaChanList methodsFor: 'model' stamp: 'AttilaMagyar 11/4/2012 21:32'!
index: anInteger
	| chan |	
	chans index: anInteger.
	chan := chans list at: anInteger.
	announcer announce: (ChanSelected chan: chan).
	chanListMorph changed: #index.! !

!IrkaChanList methodsFor: 'initialization' stamp: 'AttilaMagyar 11/5/2012 21:43'!
initialize
	| buttonsPanel |
	super initialize.
	announcer := Announcer new.
	chans := IrkaListModel new.
	chanListMorph := self createChanList.
	self
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cellInset: 1;
		layoutInset: 1.
	buttonsPanel := IrkaPanels horizontalPane
		addMorph: (self button: 'Leave channel' action: #leaveChan);
		addMorph: (self button: 'Join channel' action: #joinChan);
		vResizing: #shrinkWrap;	
		yourself.
	self
		addMorph: buttonsPanel;
		addMorph: chanListMorph! !

!IrkaChanList methodsFor: 'user actions' stamp: 'AttilaMagyar 11/4/2012 22:00'!
joinChan
	| chanName |
	chanName := UIManager default request: 'Channel name:'.
	chanName 
		ifNotNil: [ session joinChan: chanName ].! !

!IrkaChanList methodsFor: 'user actions' stamp: 'AttilaMagyar 11/4/2012 22:19'!
leaveChan
	session leaveChan: chanListMorph selection! !

!IrkaChanList methodsFor: 'model' stamp: 'AttilaMagyar 11/2/2012 21:58'!
list
	^ chans list! !

!IrkaChanList methodsFor: 'model' stamp: 'AttilaMagyar 11/2/2012 21:58'!
menu
	^ chans menu! !

!IrkaChanList methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/4/2012 22:17'!
removeChan: anIrkaChannel
	chans remove: anIrkaChannel.
	self changed: #list.! !

!IrkaChanList methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/4/2012 21:34'!
selectChan: anIrkaChannel 
	chanListMorph selection: anIrkaChannel printString.! !

!IrkaChanList methodsFor: 'initialization' stamp: 'AttilaMagyar 11/4/2012 21:55'!
setSession: anIrkaSession 
	session := anIrkaSession! !

PanelMorph subclass: #IrkaMessagesMorph
	instanceVariableNames: 'messages listBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaMessagesMorph methodsFor: 'adding' stamp: 'AttilaMagyar 11/2/2012 19:28'!
addMessage: message
	messages add: message.
	listBox selectionIndex: messages size.
	listBox 
		scrollSelectionIntoView;
		changed.! !

!IrkaMessagesMorph methodsFor: 'initialization' stamp: 'AttilaMagyar 11/2/2012 19:18'!
initialize 
	super initialize.
	self hResizing: #spaceFill; vResizing: #spaceFill; color: Color transparent; layoutPolicy: TableLayout new.
	messages := IrkaListModel new.
	listBox := (PluggableListMorph 
				on: messages list: #list selected: #index changeSelected: #index: menu: #menu) 
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				yourself.
	self addMorph: listBox.! !

PluggableListMorph subclass: #IrkaNickList
	instanceVariableNames: 'nicks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaNickList methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/2/2012 18:19'!
addNick: aString
	nicks add: aString.! !

!IrkaNickList methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/2/2012 18:20'!
clean
	nicks clean.! !

!IrkaNickList methodsFor: 'initialization' stamp: 'AttilaMagyar 11/2/2012 18:28'!
initialize 
	super initialize.    
	nicks := IrkaListModel new.
	self 
		on: nicks
		list: #list 
		selected: #index 
		changeSelected: #index: 
		menu: #menu
		keystroke: nil.
	self 
		hResizing: #spaceFill; 
		vResizing: #spaceFill.
	! !

!IrkaNickList methodsFor: 'adding - removing' stamp: 'AttilaMagyar 11/3/2012 18:55'!
removeNick: aString
	nicks remove: aString.! !

PluggableListMorph subclass: #IrkaServerList
	instanceVariableNames: 'servers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaServerList methodsFor: 'adding' stamp: 'AttilaMagyar 11/2/2012 19:33'!
addServer: aString
	servers add: aString! !

!IrkaServerList methodsFor: 'initialization' stamp: 'AttilaMagyar 11/2/2012 19:34'!
initialize 
	super initialize.    
	servers := IrkaListModel new.
	self 
		on: servers
		list: #list 
		selected: #index 
		changeSelected: #index: 
		menu: #menu
		keystroke: nil.
	self 
		hResizing: #spaceFill; 
		vResizing: #spaceFill.
	! !

Announcement subclass: #ChanSelected
	instanceVariableNames: 'chan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!ChanSelected class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/2/2012 22:08'!
chan: anIrkaChannel 
	^ self new setChan: anIrkaChannel.! !

!ChanSelected methodsFor: 'accessing' stamp: 'AttilaMagyar 11/2/2012 21:51'!
chan
	^ chan! !

!ChanSelected methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/2/2012 21:50'!
setChan: anIrkaChannel
	chan := anIrkaChannel! !

Announcement subclass: #IrkaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaAction subclass: #IrkaChanMessage
	instanceVariableNames: 'chan message senderUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaChanMessage class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/27/2012 23:26'!
message: message on: anIrkaChan fromUser: anIrkaUser
	^ self new 
			setMessage: message 
			on: anIrkaChan
			from: anIrkaUser! !

!IrkaChanMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 23:47'!
= anObject
	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ senderUser = anObject user and: [ chan = anObject chan and: [ message = anObject message ] ]! !

!IrkaChanMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 9/22/2012 23:04'!
chan
	^ chan! !

!IrkaChanMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:22'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ senderUser hash bitXor: (chan hash bitXor: message hash)! !

!IrkaChanMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 9/22/2012 23:04'!
message
	^ message! !

!IrkaChanMessage methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 20:58'!
printOn: aStream
	aStream 
		print: senderUser;
		nextPutAll: ' sent message: ';
		print: message;
		nextPutAll: ' to: ';
		print: chan.! !

!IrkaChanMessage methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 23:35'!
setMessage: aMessage on: anIrkaChannel from: anIrkaUser
	message := aMessage.
	chan := anIrkaChannel.
	senderUser := anIrkaUser.! !

!IrkaChanMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:58'!
user
	^ senderUser! !

IrkaAction subclass: #IrkaChanNickList
	instanceVariableNames: 'nicks chan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaChanNickList class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/2/2012 21:18'!
nicks: anArray on: anIrkaChannel 
	^ self new
		setNicks: anArray
		chan: anIrkaChannel! !

!IrkaChanNickList methodsFor: 'comparing' stamp: 'AttilaMagyar 11/2/2012 21:23'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ nicks = anObject nicks and: [ chan = anObject chan ]! !

!IrkaChanNickList methodsFor: 'accessing' stamp: 'AttilaMagyar 11/2/2012 21:23'!
chan
	^ chan! !

!IrkaChanNickList methodsFor: 'comparing' stamp: 'AttilaMagyar 11/2/2012 21:23'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ nicks hash bitXor: chan hash! !

!IrkaChanNickList methodsFor: 'accessing' stamp: 'AttilaMagyar 11/2/2012 21:23'!
nicks
	^ nicks! !

!IrkaChanNickList methodsFor: 'printing' stamp: 'AttilaMagyar 11/2/2012 21:22'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: 'Nick list ';
		print: nicks.
	aStream
		nextPutAll: ' on chan: ';
		print: chan! !

!IrkaChanNickList methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/3/2012 19:20'!
setNicks: anArray chan: anIrkaChannel 
	nicks := anArray collect: 
				[:each | 	"TODO represents nicks as object"
				(each beginsWithAnyOf: #('@', '+')) 
					ifTrue: [ each allButFirst: 1 ]
					ifFalse: [ each ] ].
	chan := anIrkaChannel.! !

IrkaAction subclass: #IrkaJoined
	instanceVariableNames: 'chan user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaJoined subclass: #IrkaClientJoined
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaJoined class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/28/2012 17:51'!
user: anIrkaUser to: anIrkaChan
	^ self new 
			setUser: anIrkaUser 
			chan: anIrkaChan! !

!IrkaJoined methodsFor: 'comparing' stamp: 'AttilaMagyar 10/28/2012 00:31'!
= anObject
	"Answer whether the receiver and anObject represent the same object."
	
	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ chan = anObject chan and: [ user = anObject user ]! !

!IrkaJoined methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 00:16'!
chan
	^ chan! !

!IrkaJoined methodsFor: 'comparing' stamp: 'AttilaMagyar 10/28/2012 00:18'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ chan hash bitXor: user hash! !

!IrkaJoined methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 00:16'!
printOn: aStream
	aStream 
		print: user;
		nextPutAll: ' joined to: ';
		print: chan.! !

!IrkaJoined methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 19:33'!
setUser: anIrkaUser chan: anIrkaChan
	user := anIrkaUser.
	chan := anIrkaChan.! !

!IrkaJoined methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 00:16'!
user
	^ user! !

IrkaJoined subclass: #IrkaUserJoined
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaAction subclass: #IrkaLeft
	instanceVariableNames: 'chan user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaLeft subclass: #IrkaClientLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaLeft class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/3/2012 17:46'!
user: anIrkaUser from: anIrkaChannel 
	^ self new
		setUser: anIrkaUser 
		chan: anIrkaChannel! !

!IrkaLeft methodsFor: 'comparing' stamp: 'AttilaMagyar 11/3/2012 17:57'!
= anObject
	"Answer whether the receiver and anObject represent the same object."
	
	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ chan = anObject chan ]! !

!IrkaLeft methodsFor: 'accessing' stamp: 'AttilaMagyar 11/3/2012 17:44'!
chan
	^ chan! !

!IrkaLeft methodsFor: 'comparing' stamp: 'AttilaMagyar 11/3/2012 17:45'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: chan hash! !

!IrkaLeft methodsFor: 'printing' stamp: 'AttilaMagyar 11/3/2012 17:46'!
printOn: aStream
	aStream
		nextPutAll: 'User: ';
		print: user.
	aStream
		nextPutAll: ' left: ';
		print: chan
! !

!IrkaLeft methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/3/2012 17:45'!
setUser: anIrkaUser chan: anIrkaChannel 
	user := anIrkaUser.
	chan := anIrkaChannel.! !

!IrkaLeft methodsFor: 'accessing' stamp: 'AttilaMagyar 11/3/2012 17:44'!
user
	^ user! !

IrkaLeft subclass: #IrkaUserLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaAction subclass: #IrkaPrivMessage
	instanceVariableNames: 'message senderUser session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaPrivMessage class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/27/2012 23:54'!
message: message fromUser: anIrkaUser session: anIrkaSession
	^ self new 
			setMessage: message 
			senderUser: anIrkaUser
			session: anIrkaSession! !

!IrkaPrivMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/28/2012 00:05'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ senderUser = anObject senderUser and: 
		[ session identityHash = anObject session identityHash and: 
		[ message = anObject message ] ]! !

!IrkaPrivMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 23:54'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ senderUser hash bitXor: (session hash bitXor: message hash)! !

!IrkaPrivMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:53'!
message
	^ message! !

!IrkaPrivMessage methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 20:57'!
printOn: aStream
	aStream 
		print: senderUser;
		nextPutAll: ' sent message: ';
		print: message;
		nextPutAll: ' session: ';
		print: session.! !

!IrkaPrivMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:54'!
senderUser
	^ senderUser! !

!IrkaPrivMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:54'!
session
	^ session! !

!IrkaPrivMessage methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 20:52'!
setMessage: messageString senderUser: anIrkaUser session: anIrkaSession 
	message := messageString.
	senderUser := anIrkaUser.
	session := anIrkaSession.! !

IrkaAction subclass: #IrkaUserChangedNick
	instanceVariableNames: 'user oldNick newNick affectedChans'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaUserChangedNick class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/9/2012 23:40'!
user: anIrkaUser from: oldNickString to: newNickString affectedChans: irkaChannelCollection
	^ self new
		setUser: anIrkaUser 
		oldNick: oldNickString
		newNick: newNickString
		affectedChans: irkaChannelCollection! !

!IrkaUserChangedNick methodsFor: 'comparing' stamp: 'AttilaMagyar 11/10/2012 00:03'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ oldNick = anObject oldNick and: [ newNick = anObject newNick and: [ affectedChans = anObject affectedChans ] ] ]	! !

!IrkaUserChangedNick methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 23:41'!
affectedChans
	^ affectedChans ! !

!IrkaUserChangedNick methodsFor: 'comparing' stamp: 'AttilaMagyar 11/9/2012 23:43'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: (oldNick hash bitXor: (newNick hash bitXor: affectedChans hash))! !

!IrkaUserChangedNick methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 22:45'!
newNick
	^ newNick! !

!IrkaUserChangedNick methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 22:45'!
oldNick
	^ oldNick! !

!IrkaUserChangedNick methodsFor: 'printing' stamp: 'AttilaMagyar 11/10/2012 12:52'!
printOn: aStream
	aStream
		nextPutAll: 'User: ';
		print: user.
	aStream
		nextPutAll: ' changed nick from: ';
		print: oldNick.
	aStream
		nextPutAll: ' to: ';
		print: newNick.
	aStream
		nextPutAll: ' affected chans: ';
		print: affectedChans! !

!IrkaUserChangedNick methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/9/2012 23:40'!
setUser: anIrkaUser oldNick: oldNickString newNick: newNickString affectedChans: irkaChannelCollection
	user := anIrkaUser.
	oldNick := oldNickString.
	newNick := newNickString.
	affectedChans := irkaChannelCollection.! !

!IrkaUserChangedNick methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 22:45'!
user
	^ user! !

IrkaAction subclass: #IrkaUserQuit
	instanceVariableNames: 'user quitMessage affectedChans'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaUserQuit class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/9/2012 20:53'!
user: anIrkaUser withQuitMessage: aString affectedChans: anIrkaChannelCollection
	^ self new
		setUser: anIrkaUser 
		quitMessage: aString
		affectedChans: anIrkaChannelCollection ! !

!IrkaUserQuit methodsFor: 'comparing' stamp: 'AttilaMagyar 11/9/2012 21:00'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ quitMessage = anObject quitMessage and: [ affectedChans = anObject affectedChans ] ]	! !

!IrkaUserQuit methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 20:55'!
affectedChans
	^ affectedChans! !

!IrkaUserQuit methodsFor: 'comparing' stamp: 'AttilaMagyar 11/9/2012 20:57'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: (quitMessage hash bitXor: affectedChans hash)! !

!IrkaUserQuit methodsFor: 'printing' stamp: 'AttilaMagyar 11/9/2012 20:58'!
printOn: aStream
	aStream
		nextPutAll: 'User: ';
		print: user.
	aStream
		nextPutAll: ' quit: ';
		print: quitMessage.
	aStream
		nextPutAll: ' affected chans: ';
		print: affectedChans.! !

!IrkaUserQuit methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 20:26'!
quitMessage
	^ quitMessage! !

!IrkaUserQuit methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/9/2012 20:53'!
setUser: anIrkaUser quitMessage: aByteString affectedChans: anIrkaChannelCollection 
	user := anIrkaUser.
	quitMessage := aByteString.
	affectedChans := anIrkaChannelCollection ! !

!IrkaUserQuit methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 20:26'!
user
	^ user! !

Announcement subclass: #IrkaTranslatedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

IrkaTranslatedEvent subclass: #IrkaTranslatedEndOfNameList
	instanceVariableNames: 'chanName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedEndOfNameList methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/10/2012 12:52'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ chanName = anObject chanName! !

!IrkaTranslatedEndOfNameList methodsFor: 'accessing' stamp: 'AttilaMagyar 11/10/2012 12:57'!
chanName
	^ chanName! !

!IrkaTranslatedEndOfNameList methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/10/2012 12:52'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ chanName hash! !

!IrkaTranslatedEndOfNameList methodsFor: 'printing' stamp: 'AttilaMagyar 11/10/2012 12:52'!
printOn: aStream
	aStream
		nextPutAll: 'EndOfNameList ';
		print: chanName.! !

!IrkaTranslatedEndOfNameList methodsFor: 'comparing' stamp: 'AttilaMagyar 11/10/2012 12:48'!
setChanName: chanNameString
	chanName := chanNameString! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/10/2012 12:48'!
endOfNameList: chanName 
	^ IrkaTranslatedEndOfNameList new 
			setChanName: chanName.! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/28/2012 18:24'!
message: msg from: anIrkaUser to: chanOrNickString
	^ IrkaTranslatedMessage new 
			setSenderUser: anIrkaUser
			recipient: chanOrNickString
			message: msg.! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/27/2012 01:11'!
nickList: anArray on: chanName
	^ IrkaTranslatedNameList new 
					setNicks: anArray 
					chanName: chanName.! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/9/2012 22:23'!
user: anIrkaUser changedNickFrom: oldNick to: newNick
	^ IrkaTranslatedNickChange new 
			setUser: anIrkaUser
			oldNick: oldNick
			newNick: newNick! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/3/2012 17:12'!
user: anIrkaUser joinedTo: chanName
	^ IrkaTranslatedJoin new 
			setUser: anIrkaUser
			chanName: chanName! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/3/2012 17:05'!
user: anIrkaUser left: chanName
	^ IrkaTranslatedLeave new
		setUser: anIrkaUser
		chanName: chanName ! !

!IrkaTranslatedEvent class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/9/2012 20:21'!
user: anIrkaUser quitWithMessage: aString
	^ IrkaTranslatedQuit new
		setUser: anIrkaUser
		quitMessage: aString! !

IrkaTranslatedEvent subclass: #IrkaTranslatedJoin
	instanceVariableNames: 'user chanName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedJoin methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:53'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ chanName = anObject chanName ]! !

!IrkaTranslatedJoin methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 01:16'!
chanName 
	^ chanName! !

!IrkaTranslatedJoin methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:53'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: chanName hash! !

!IrkaTranslatedJoin methodsFor: 'printing' stamp: 'AttilaMagyar 11/3/2012 17:35'!
printOn: aStream
	aStream
		nextPutAll: 'User joined: ';
		print: user;
		nextPutAll: ' to ';
		print: chanName! !

!IrkaTranslatedJoin methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 01:10'!
setUser: anIrkaUser chanName: aString
	user := anIrkaUser.
	chanName := aString.! !

!IrkaTranslatedJoin methodsFor: 'accessing' stamp: 'AttilaMagyar 10/26/2012 23:33'!
user
	^ user! !

IrkaTranslatedEvent subclass: #IrkaTranslatedLeave
	instanceVariableNames: 'user chanName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedLeave methodsFor: 'comparing' stamp: 'AttilaMagyar 11/3/2012 17:07'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ chanName = anObject chanName ]! !

!IrkaTranslatedLeave methodsFor: 'accessing' stamp: 'AttilaMagyar 11/3/2012 17:07'!
chanName
	^ chanName! !

!IrkaTranslatedLeave methodsFor: 'comparing' stamp: 'AttilaMagyar 11/3/2012 17:07'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: chanName hash! !

!IrkaTranslatedLeave methodsFor: 'printing' stamp: 'AttilaMagyar 11/3/2012 17:08'!
printOn: aStream
	aStream
		nextPutAll: 'User: ';
		print: user.
	aStream
		nextPutAll: ' left: ';
		print: chanName! !

!IrkaTranslatedLeave methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/3/2012 17:05'!
setUser: anIrkaUser chanName: aByteString 
	user := anIrkaUser.
	chanName := aByteString.! !

!IrkaTranslatedLeave methodsFor: 'accessing' stamp: 'AttilaMagyar 11/3/2012 17:07'!
user
	^ user! !

IrkaTranslatedEvent subclass: #IrkaTranslatedMessage
	instanceVariableNames: 'message user recipientName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:58'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ message = anObject message and: [ user = anObject senderUser and: [ recipientName = anObject recipientName ] ]! !

!IrkaTranslatedMessage methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:58'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ message hash bitXor: (user hash bitXor: recipientName hash)! !

!IrkaTranslatedMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:08'!
message
	^ message! !

!IrkaTranslatedMessage methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 23:01'!
printOn: aStream
	aStream
		nextPutAll: 'Message: ';
		print: message;
		nextPutAll: ' from: ';
		print: user;
		nextPutAll: ' to: ';
		print: recipientName! !

!IrkaTranslatedMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:26'!
recipientName 
	^ recipientName ! !

!IrkaTranslatedMessage methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:21'!
senderUser
	^ user! !

!IrkaTranslatedMessage methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 20:26'!
setSenderUser: anIrkaUser recipient: chanOrNickString message: messageString
	user := anIrkaUser.
	recipientName := chanOrNickString.
	message := messageString.! !

IrkaTranslatedEvent subclass: #IrkaTranslatedNameList
	instanceVariableNames: 'nicks chanName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedNameList methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:47'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ nicks = anObject nicks and: [ chanName = anObject chanName ]! !

!IrkaTranslatedNameList methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 01:19'!
chanName
	^ chanName! !

!IrkaTranslatedNameList methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:47'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ nicks hash bitXor: chanName hash! !

!IrkaTranslatedNameList methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 00:33'!
nicks
	^ nicks! !

!IrkaTranslatedNameList methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 22:52'!
printOn: aStream
	aStream
		nextPutAll: 'Translated namelist: ';
		print: nicks;
		nextPutAll: ' chanName: ';
		print: chanName! !

!IrkaTranslatedNameList methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 01:12'!
setNicks: anArray chanName: aString 
	nicks := anArray.
	chanName := aString.! !

IrkaTranslatedEvent subclass: #IrkaTranslatedNickChange
	instanceVariableNames: 'user oldNick newNick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedNickChange methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 22:48'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ newNick = anObject newNick and: [ oldNick = anObject oldNick ] ]	! !

!IrkaTranslatedNickChange methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 22:46'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: (newNick hash bitXor: oldNick hash)	! !

!IrkaTranslatedNickChange methodsFor: 'comparing' stamp: 'AttilaMagyar 11/9/2012 22:48'!
newNick
	^ newNick! !

!IrkaTranslatedNickChange methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 22:33'!
oldNick
	^ oldNick! !

!IrkaTranslatedNickChange methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/9/2012 22:46'!
printOn: aStream
	aStream
		nextPutAll: 'User: ';
		print: user;
		nextPutAll: ' changed nick from: ';
		print: oldNick;	
		nextPutAll: ' to: ';
		print: newNick! !

!IrkaTranslatedNickChange methodsFor: 'printing' stamp: 'AttilaMagyar 11/9/2012 22:46'!
setUser: anIrkaUser oldNick: oldNickString newNick: newNickString
	user := anIrkaUser.
	oldNick := oldNickString.
	newNick := newNickString.! !

!IrkaTranslatedNickChange methodsFor: 'comparing' stamp: 'AttilaMagyar 9/25/2012 14:19'!
user
	^ user! !

IrkaTranslatedEvent subclass: #IrkaTranslatedQuit
	instanceVariableNames: 'user quitMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaTranslatedQuit methodsFor: 'comparing' stamp: 'AttilaMagyar 11/6/2012 22:54'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ user = anObject user and: [ quitMessage = anObject quitMessage ]! !

!IrkaTranslatedQuit methodsFor: 'comparing' stamp: 'AttilaMagyar 11/6/2012 22:53'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ user hash bitXor: quitMessage hash! !

!IrkaTranslatedQuit methodsFor: 'printing' stamp: 'AttilaMagyar 11/6/2012 22:52'!
printOn: aStream
	aStream
		nextPutAll: 'User: ';
		print: user;
		nextPutAll: ' quit ';
		print: quitMessage! !

!IrkaTranslatedQuit methodsFor: 'accessing' stamp: 'AttilaMagyar 11/6/2012 22:54'!
quitMessage
	^ quitMessage ! !

!IrkaTranslatedQuit methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/6/2012 22:44'!
setUser: anIrkaUser quitMessage: aByteString 
	user := anIrkaUser.
	quitMessage := aByteString.! !

!IrkaTranslatedQuit methodsFor: 'accessing' stamp: 'AttilaMagyar 11/6/2012 22:54'!
user
	^ user! !

Announcement subclass: #RawLineReceived
	instanceVariableNames: 'sender command args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!RawLineReceived class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/27/2012 19:41'!
parse: line
	| args command tokens sender |
	args := line findTokens: ' '.
	tokens := args removeFirst: 2.
	sender := tokens at: 1.
	command := tokens at: 2.
	args := ' ' join: args.
	^ self new 
			setSender: sender
			command: command
			args: args! !

!RawLineReceived methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:51'!
args
	^ args! !

!RawLineReceived methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:51'!
command
	^ command! !

!RawLineReceived methodsFor: 'printing' stamp: 'AttilaMagyar 10/27/2012 22:45'!
printOn: aStream
	aStream 
		print: 'command: ';
		print: command;
		print: ' with: ';
		print: args;
		print: ' from: ';
		print: sender.! !

!RawLineReceived methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:51'!
sender
	^ sender! !

!RawLineReceived methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/27/2012 19:42'!
setSender: senderString command: commandString args: argsString
	sender := senderString.
	command := commandString.
	args := argsString.! !

Error subclass: #IrkaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

BabyMockTestCase subclass: #IrkaChanListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaChanListTest methodsFor: 'tests' stamp: 'AttilaMagyar 11/3/2012 19:11'!
testThatItStripsModeFlag
	"TODO represents nicks as objects"
	| list |
	list := IrkaChanNickList 
		nicks: #('@nick1' '+nick2') 
		on: nil.
	self assert: list nicks equals: #('nick1' 'nick2').! !

BabyMockTestCase subclass: #IrkaChannelTest
	instanceVariableNames: 'chan translator testUser listener chanName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaChannelTest methodsFor: 'running' stamp: 'AttilaMagyar 10/27/2012 22:33'!
setUp	
	chanName := '#mychan'.
	translator := context mock: 'translator'.
	chan := IrkaChannel 
					named: chanName 
					translator: translator.
	testUser := IrkaUser parse: 'nick!!ident@host'.
	listener := context mock: 'chan listener'.	
	context visualize: chan.! !

!IrkaChannelTest methodsFor: 'private' stamp: 'AttilaMagyar 11/2/2012 21:24'!
subscribeTo: anAnnouncement
	chan announcer 
			on: anAnnouncement
			send: #announced:
			to: listener.							
! !

!IrkaChannelTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/27/2012 22:33'!
testThatItCanBeLeft
	translator should receive: #translateLeave:; with: chanName.
	chan leave.! !

!IrkaChannelTest methodsFor: 'tests' stamp: 'AttilaMagyar 10/27/2012 22:33'!
testThatItCanSendMessagesToTheChan
	translator should receive: #translateMessage:to:; with: 'text' and: chanName.
	chan message: 'text'.! !

!IrkaChannelTest methodsFor: 'tests' stamp: 'AttilaMagyar 11/2/2012 21:24'!
testThatItNotifiesAboutIncomingMessages
	self subscribeTo: IrkaChanMessage.
	listener should 
					receive: #announced:; 
					with: (IrkaChanMessage 
								message: 'text' 
								on: chan 
								fromUser: testUser).	
	chan message: 'text' from: testUser.! !

!IrkaChannelTest methodsFor: 'tests' stamp: 'AttilaMagyar 11/2/2012 21:23'!
testThatItNotifiesAboutNicklist
	self subscribeTo: IrkaChanNickList.
	listener should 
					receive: #announced:; 
					with: (IrkaChanNickList
								nicks: #('nick1', 'nick2')
								on: chan).	
	chan nicks: #('nick1', 'nick2').! !

BabyMockTestCase subclass: #IrkaSessionTest
	instanceVariableNames: 'session translator me listener meUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaSessionTest methodsFor: 'matchers' stamp: 'AttilaMagyar 10/26/2012 23:55'!
chan: anIrkaChannel hasNicks: anArray 
	^ anIrkaChannel nicks = (OrderedCollection newFrom: anArray).! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 16:24'!
joined: chanName
	| joinedChan |
	session announcer 
		on: IrkaClientJoined 
		do: [:act | joinedChan := act chan ].
	session joined: (IrkaTranslatedEvent 
		user: meUser 
		joinedTo: chanName).
	^ joinedChan! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 10/27/2012 20:36'!
registerNick
	translator can receive: #translateRegisterUser:; with: me.
	session register: me.
! !

!IrkaSessionTest methodsFor: 'running' stamp: 'AttilaMagyar 10/28/2012 18:29'!
setUp
	me := 'mynick'.
	meUser := IrkaUser parse: (me, '!!ident@host.hu').
	session := IrkaSession new.
	translator := context mock: 'translator'.
	listener := context mock: 'listener'.
	session translator: translator.
	context visualize: session.! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 16:24'!
subscribeToSession: anAnnouncement
	session announcer 
		on: anAnnouncement
		send: #announced:
		to: listener
! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 9/23/2012 18:50'!
testThatItCanChangeNick
	translator should receive: #translateChangeNick:; with: 'newnick'.
	session changeNick: 'newnick'.
! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 9/22/2012 23:48'!
testThatItCanJoinToChan
	translator should receive: #translateJoin:; with: '#chan'.
	session joinChan: '#chan'.
! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 11/3/2012 19:42'!
testThatItCanLeaveChan
	translator should receive: #translateLeave:; with: '#chan'.
	session leaveChan: '#chan'.
! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 9/26/2012 19:30'!
testThatItCanQuit
	translator should receive: #translateQuit.
	session close.
! !

!IrkaSessionTest methodsFor: 'test - events - messages' stamp: 'AttilaMagyar 11/3/2012 18:10'!
testThatItForwardsIncomingMessageToChan
	| chan event senderUser |
	self registerNick.
	chan := self joined: '#chan'.	
	senderUser := IrkaUser parse: 'nick!!ident@host'.
	chan announcer on: IrkaChanMessage send: #msg: to: listener.	
	event := IrkaChanMessage 
					message: 'text'
					on: chan
					fromUser: senderUser.
					
	listener should receive: #msg:; with: event.
	self user: senderUser said: 'text' to: '#chan'.! !

!IrkaSessionTest methodsFor: 'test - events - messages' stamp: 'AttilaMagyar 10/28/2012 18:48'!
testThatItForwardsIncomingMessageToMe
	| event senderUser |		
	senderUser := IrkaUser parse: 'nick!!ident@host'.
	self registerNick.	
	self subscribeToSession: IrkaPrivMessage.
	event := IrkaPrivMessage 
					message: 'text'					
					fromUser: senderUser
					session: session.

	listener should receive: #announced:; with: event.	
	self user: senderUser said: 'text' to: me.! !

!IrkaSessionTest methodsFor: 'test - events - join/part' stamp: 'AttilaMagyar 11/3/2012 18:07'!
testThatItNotifiesWhenIjoinedToChan
	| event |
	self registerNick.
	self subscribeToSession: IrkaClientJoined.
	event := IrkaClientJoined 
					user: meUser
					to: (IrkaChannel 
								named: '#chan' 
								translator: translator).
								
	listener should receive: #announced:; with: event.		
	self joined: '#chan'.
! !

!IrkaSessionTest methodsFor: 'test - events - join/part' stamp: 'AttilaMagyar 11/3/2012 17:29'!
testThatItNotifiesWhenUserJoinedToChan
	| event user |
	user := IrkaUser parse: 'user!!ident@host'.	
	event := IrkaUserJoined
					user: user
					to: (IrkaChannel 
								named: '#chan' 
								translator: translator).
	self subscribeToSession: IrkaUserJoined.
			
	listener should receive: #announced:; with: event.	
	self user: user joinedTo: '#chan'.
! !

!IrkaSessionTest methodsFor: 'test - events - join/part' stamp: 'AttilaMagyar 11/3/2012 18:09'!
testThatItRecordsJoinedUsersInChannels
	| chan1 chan2 |			
	self registerNick.				
	chan1 := self joined: '#chan1'.
	chan2 := self joined: '#chan2'.			
	self user: (IrkaUser parse: 'nick!!ident@host') joinedTo: '#chan1'.
	self assert: (self chan: chan1 hasNicks: {me. 'nick'}).
	self assert: (self chan: chan2 hasNicks: {me}).! !

!IrkaSessionTest methodsFor: 'tests - events - nicks' stamp: 'AttilaMagyar 11/10/2012 16:26'!
testThatItRecordsUsersAfterNickListReceived
	| chan |
	self registerNick.
	chan := self joined: '#chan'.
	session nickListReceived: (IrkaTranslatedEvent 
									nickList: #(nick1 nick2) 
									on: '#chan').
	session endOfNameList: (IrkaTranslatedEvent endOfNameList: '#chan'). 												
	self assert: (self 
						chan: chan 
						hasNicks: {'nick1'. 'nick2'}). ! !

!IrkaSessionTest methodsFor: 'tests - events - nicks' stamp: 'AttilaMagyar 11/10/2012 16:26'!
testThatItRecordsUsersAfterNickListReceivedInTwoParts
	| chan |
	self registerNick.
	chan := self joined: '#chan'.
	session nickListReceived: (IrkaTranslatedEvent 
									nickList: #(nick1 nick2) 
									on: '#chan').
	session nickListReceived: (IrkaTranslatedEvent 
									nickList: #(nick3) 
									on: '#chan').	
	session endOfNameList: (IrkaTranslatedEvent endOfNameList: '#chan'). 										
	self assert: (self 
						chan: chan 
						hasNicks: {'nick1'. 'nick2'. 'nick3'}). ! !

!IrkaSessionTest methodsFor: 'tests - commands' stamp: 'AttilaMagyar 9/26/2012 22:49'!
testThatItRegistersItself
	translator should receive: #translateRegisterUser:; with: me.
	session register: me.
! !

!IrkaSessionTest methodsFor: 'tests - events - nicks' stamp: 'AttilaMagyar 11/10/2012 16:26'!
testThatItRemembersItsNick
	self registerNick.
	session nickChanged: (IrkaTranslatedEvent 
									user: meUser
									changedNickFrom: me
									to: 'newnick').
	self assert: session nick equals: 'newnick'.
		
	session nickChanged: (IrkaTranslatedEvent 
									user: (IrkaUser parse: 'newnick!!me@host')
									changedNickFrom: 'newnick'
									to: 'newest').
	self assert: session nick equals: 'newest'.! !

!IrkaSessionTest methodsFor: 'test - events - quit' stamp: 'AttilaMagyar 11/9/2012 20:36'!
testThatItRemovesNickFromChanWhenUserQuit
	| user chan |
	self registerNick.
	chan := self joined: '#chan'.
	user := IrkaUser parse: 'nick!!ident@host'.		
	self user: user joinedTo: '#chan'.
	self assert: (self 
						chan: chan 
						hasNicks: {me. user nick}).
	self user: user quitWithMessage: 'bye'.
	self assert: (self 
						chan: chan 
						hasNicks: {me}).	! !

!IrkaSessionTest methodsFor: 'test - events - join/part' stamp: 'AttilaMagyar 11/9/2012 20:30'!
testThatItRemovesUserWhoLeftTheChan
	| chan user1 user2 |
	self registerNick.
	user1 := 	IrkaUser parse: 'nick1!!ident@host'.
	user2 := 	IrkaUser parse: 'nick1!!ident@host'.		
	chan := self joined: '#chan'.
	self user: user1 joinedTo: '#chan'.
	self user: user2 joinedTo: '#chan'.
	self user: user2 left: '#chan'.
	self assert: (self chan: chan hasNicks: {me . user2 nick}).! !

!IrkaSessionTest methodsFor: 'tests - events - nicks' stamp: 'AttilaMagyar 11/10/2012 16:26'!
testThatItRenamesNickWhenUserChangedNick
	| user event chan |
	self registerNick.
	chan := self joined: '#chan'.
	user := IrkaUser parse: 'old!!me@host'.
	self user: user joinedTo: '#chan'.	
		
	self assert: (self 
						chan: chan 
						hasNicks: {me. 'old'}).
	session nickChanged: (IrkaTranslatedEvent 
									user: user
									changedNickFrom: 'old'
									to: 'new').
	self assert: (self 
						chan: chan 
						hasNicks: {me. 'new'}).! !

!IrkaSessionTest methodsFor: 'test - events - join/part' stamp: 'AttilaMagyar 11/3/2012 17:58'!
testThatItSendNotificationWhenClientLeftTheChan
	| chan event |			
	self registerNick.
	chan := self joined: '#chan'.	
	self subscribeToSession: IrkaClientLeft.
	event := IrkaClientLeft 
		user: meUser
		from: chan.
			
	listener should receive: #announced:; with: event.
	self user: meUser left: '#chan'.
	! !

!IrkaSessionTest methodsFor: 'test - events - join/part' stamp: 'AttilaMagyar 11/3/2012 18:11'!
testThatItSendNotificationWhenUserLeftTheChan
	| chan user event |			
	self registerNick.
	chan := self joined: '#chan'.			
	user := IrkaUser parse: 'nick1!!ident@host'.				
	self subscribeToSession: IrkaUserLeft.
	event := IrkaUserLeft 
		user: user
		from: chan.	
			
	listener should receive: #announced:; with: event.
	self user: user joinedTo: '#chan'.
	self user: user left: '#chan'.
	! !

!IrkaSessionTest methodsFor: 'test - events - quit' stamp: 'AttilaMagyar 11/9/2012 21:20'!
testThatItSendsNotificationAboutQuit
	| event user chan |
	self registerNick.
	chan := self joined: '#chan'.	
	user := IrkaUser parse: 'user!!ident@host'.	
	event := IrkaUserQuit
					user: user
					withQuitMessage: 'bye'
					affectedChans: {chan}.
	self subscribeToSession: IrkaUserQuit.		
	listener should receive: #announced:; with: event.	
	self user: user joinedTo: '#chan'.
	self user: user quitWithMessage: 'bye'.! !

!IrkaSessionTest methodsFor: 'tests - events - nicks' stamp: 'AttilaMagyar 11/10/2012 16:27'!
testThatItSendsNotificationWhenUserChangedNick
	| user event chan |
	self registerNick.
	chan := self joined: '#chan'.	
	user := IrkaUser parse: 'old!!me@host'.
	self user: user joinedTo: '#chan'.	
	self subscribeToSession: IrkaUserChangedNick.
	event := IrkaUserChangedNick
		user: user
		from: 'old'
		to: 'new'
		affectedChans: {chan}.
	listener should receive: #announced:; with: event.	
	session nickChanged: (IrkaTranslatedEvent 
									user: user
									changedNickFrom: 'old'
									to: 'new').! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 16:25'!
user: anIrkaUser joinedTo: chanName
	session joined: (IrkaTranslatedEvent 
		user: anIrkaUser 
		joinedTo: chanName)! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 16:25'!
user: anIrkaUser left: chanName
	session left: (IrkaTranslatedEvent 
		user: anIrkaUser 
		left: chanName)! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 16:25'!
user: anIrkaUser quitWithMessage: aString
	session quit: (IrkaTranslatedEvent 
		user: anIrkaUser 
		quitWithMessage: aString)! !

!IrkaSessionTest methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 16:25'!
user: anIrkaUser said: msg to: chanOrNickString
	session messageReceived: (IrkaTranslatedEvent 
		message: msg 
		from: anIrkaUser 
		to: chanOrNickString).! !

BabyMockTestCase subclass: #IrkaTranslatorTest
	instanceVariableNames: 'translator destination listener'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaTranslatorTest methodsFor: 'running' stamp: 'AttilaMagyar 10/27/2012 22:38'!
setUp
	listener := context mock: 'listener'.
	destination := context mock: 'destination'.
	translator := IrkaIrcTranslator toDestination: destination.
	context visualize: translator.! !

!IrkaTranslatorTest methodsFor: 'private' stamp: 'AttilaMagyar 10/27/2012 22:39'!
subscribeTo: anAnnouncement
	translator announcer on: anAnnouncement send: #announced: to: listener.! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 11/10/2012 12:47'!
testThatItTranslatesEndOfNameListCommand
	| event |	
	event := IrkaTranslatedEvent endOfNameList: '#chan'.
	self subscribeTo: IrkaTranslatedEndOfNameList.
	
	listener should receive: #announced:; with: event.	
	translator translateRaw: (RawLineReceived 
		parse: ':server 366 mynick #chan :End of /NAMES list').! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesJoinMessage
	destination should receive: #send:; with: 'JOIN #chan'.
	translator translateJoin: '#chan'.! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesLeave
	destination should receive: #send:; with: 'PART #chan'.
	translator translateLeave: '#chan'.! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 10/27/2012 22:35'!
testThatItTranslatesMessage
	destination should receive: #send:; with: 'PRIVMSG #chan :some text'.
	translator 
		translateMessage: 'some text' 
		to: '#chan'.! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 11/6/2012 22:39'!
testThatItTranslatesNameListCommand
	| event |	
	event := IrkaTranslatedEvent 
					nickList: #(mynick othernick) 
					on: '#chan'.
	self subscribeTo: IrkaTranslatedNameList.	
		
	listener should receive: #announced:; with: event.	
	translator translateRaw: (RawLineReceived 
		parse: ':server 353 mynick = #chan :mynick othernick').! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 11/6/2012 22:39'!
testThatItTranslatesNameListCommandWithAtSeparator
	| event |	
	event := IrkaTranslatedEvent 
					nickList: #('@mynick') 
					on: '#chan'.
	self subscribeTo: IrkaTranslatedNameList.
	
	listener should receive: #announced:; with: event.	
	translator translateRaw: (RawLineReceived 
		parse: ':server 353 mynick @ #chan :@mynick').! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesNickChange
	destination should receive: #send:; with: 'NICK newnick'.
	translator translateChangeNick: 'newnick'.! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesQuit
	destination should receive: #send:; with: 'QUIT'.
	destination should receive: #disconnect.
	translator translateQuit.! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 11/6/2012 22:39'!
testThatItTranslatesRawJoin
	| event |	
	event := IrkaTranslatedEvent 
					user: (IrkaUser parse: 'nick!!ident@host')
					joinedTo: '#chan'.					
	self subscribeTo: IrkaTranslatedJoin.
											
	listener should receive: #announced:; with: event.
	translator translateRaw: (RawLineReceived 
		parse: 'nick!!ident@host JOIN #chan').! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 11/9/2012 22:23'!
testThatItTranslatesRawNickChange
	| event |	
	event := IrkaTranslatedEvent 
					user: (IrkaUser parse: ':nick!!~ident@host.net')
					changedNickFrom: 'nick'
					to: 'newnick'.							
	self subscribeTo: IrkaTranslatedNickChange.							
								
	listener should receive: #announced:; with: event.
	translator translateRaw: (RawLineReceived 
		parse: ':nick!!~ident@host.net NICK :newnick').! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 11/6/2012 22:39'!
testThatItTranslatesRawPart
	| event |	
	event := IrkaTranslatedEvent 
					user: (IrkaUser parse: ':nick!!ident@host')
					left: '#chan'.					
	self subscribeTo: IrkaTranslatedLeave.
											
	listener should receive: #announced:; with: event.
	translator translateRaw: (RawLineReceived 
		parse: ':nick!!ident@host PART #chan').! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 11/6/2012 22:39'!
testThatItTranslatesRawPrivMsg
	| event |	
	event := IrkaTranslatedEvent 
					message: 'msg 1 2'
					from: (IrkaUser parse: 'nick!!ident@host')
					to: '#chan'.						
	self subscribeTo: IrkaTranslatedMessage.
	
	listener should receive: #announced:; with: event.
	translator translateRaw: (RawLineReceived 
		parse: ':nick!!ident@host PRIVMSG #chan :msg 1 2').! !

!IrkaTranslatorTest methodsFor: 'tests translate irc to message' stamp: 'AttilaMagyar 11/9/2012 20:20'!
testThatItTranslatesRawQuit
	| event |	
	event := IrkaTranslatedEvent 
					user: (IrkaUser parse: 'nick!!ident@host')
					quitWithMessage: 'bye'.
	self subscribeTo: IrkaTranslatedQuit.
											
	listener should receive: #announced:; with: event.
	translator translateRaw: (RawLineReceived 
		parse: 'nick!!ident@host QUIT :bye').! !

!IrkaTranslatorTest methodsFor: 'tests translate message to irc' stamp: 'AttilaMagyar 9/26/2012 22:30'!
testThatItTranslatesRegisterMessage
	destination should receive: #send:; with: 'NICK nick'.
	destination should receive: #send:; with: 'USER nick Server 0 :nick'.	
	translator translateRegisterUser: 'nick'.! !

BabyMockTestCase subclass: #IrkaUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Test'!

!IrkaUserTest methodsFor: 'tests' stamp: 'AttilaMagyar 9/25/2012 16:11'!
testThatItCanParseHostAndNick
	| user |
	user := IrkaUser parse: ':nick!!~ident@host.hu'.
	self assert: user nick equals: 'nick'.
	self assert: user ident equals: 'ident'.
	self assert: user host equals: 'host.hu'.! !

!IrkaUserTest methodsFor: 'tests' stamp: 'AttilaMagyar 9/25/2012 16:21'!
testThatItSignalsErrorIfHostIsIncorrect
	self should: [ IrkaUser parse: 'incorrect' ] raise: IrkaError.! !

Object subclass: #Irka
	instanceVariableNames: 'connection translator session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!Irka class methodsFor: 'instance creation' stamp: 'AttilaMagyar 9/22/2012 18:42'!
host: hostName port: portNumber
	| hostIP |
	hostIP := NetNameResolver addressForName: hostName.
	^ self new ip: hostIP port: portNumber.! !

!Irka methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/23/2012 21:21'!
ip: hostIp port: portNumber
	connection := IrkaIrcConnection to: hostIp port: portNumber.
	session := IrkaSession new.
	translator := IrkaIrcTranslator toDestination: connection.
	session translator: translator.
	
	self 
		subscribeTranslatorToConnectionEvents;
		subscribeSessionToTranslatorEvents.
		
	[ connection startProcessing ] forkNamed: 'Irka-IRC'.
	^ session! !

!Irka methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 16:21'!
subscribeSessionToTranslatorEvents
	translator announcer 
		on: IrkaTranslatedEndOfNameList 
		send: #endOfNameList: 
		to: session.
	translator announcer 
		on: IrkaTranslatedJoin 
		send: #joined: 
		to: session.
	translator announcer 
		on: IrkaTranslatedLeave 
		send: #left: 
		to: session.
	translator announcer 
		on: IrkaTranslatedMessage 
		send: #messageReceived: 
		to: session.
	translator announcer 
		on: IrkaTranslatedNameList 
		send: #nickListReceived: 
		to: session.
	translator announcer 
		on: IrkaTranslatedNickChange 
		send: #nickChanged: 
		to: session.
	translator announcer 
		on: IrkaTranslatedQuit 
		send: #quit: 
		to: session.! !

!Irka methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 16:22'!
subscribeTranslatorToConnectionEvents
	connection announcer 
		on: RawLineReceived 
		send: #translateRaw: 
		to: translator! !

Object subclass: #IrkaChannel
	instanceVariableNames: 'chanName announcer translator nicks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaChannel class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/26/2012 22:09'!
named: chanName translator: anIrkaTranslator
	^ self new 
			setChanName: chanName 
			translator: anIrkaTranslator.! !

!IrkaChannel methodsFor: 'comparing' stamp: 'AttilaMagyar 11/2/2012 22:42'!
= anObject
	"Answer whether the receiver and anObject represent the same object."
	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ chanName = anObject chanName! !

!IrkaChannel methodsFor: 'adding' stamp: 'AttilaMagyar 10/26/2012 23:47'!
addNick: aString
	nicks add: aString.! !

!IrkaChannel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/16/2012 12:42'!
announcer 
	^ announcer! !

!IrkaChannel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/15/2012 23:44'!
chanName
	^ chanName! !

!IrkaChannel methodsFor: 'accessing' stamp: 'AttilaMagyar 11/9/2012 20:38'!
hasNick: aString
	^ nicks includes: aString! !

!IrkaChannel methodsFor: 'comparing' stamp: 'AttilaMagyar 10/27/2012 22:24'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ chanName hash! !

!IrkaChannel methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/26/2012 23:47'!
initialize 
	super initialize.
	nicks := OrderedCollection new.
	announcer := Announcer new.! !

!IrkaChannel methodsFor: 'commands' stamp: 'AttilaMagyar 9/23/2012 19:22'!
leave
	translator translateLeave: chanName.! !

!IrkaChannel methodsFor: 'commands' stamp: 'AttilaMagyar 10/26/2012 22:07'!
message: message
	translator 
		translateMessage: message 
		to: chanName.! !

!IrkaChannel methodsFor: 'events' stamp: 'AttilaMagyar 11/23/2012 21:32'!
message: msg from: anIrkaUser
	announcer announce: (IrkaChanMessage 
										message: msg 
										on: self 
										fromUser: anIrkaUser).! !

!IrkaChannel methodsFor: 'accessing' stamp: 'AttilaMagyar 10/26/2012 23:48'!
nicks
	^ nicks! !

!IrkaChannel methodsFor: 'adding' stamp: 'AttilaMagyar 11/3/2012 19:21'!
nicks: arrayOfNicks
	| nickList |
	nickList := IrkaChanNickList
		nicks: arrayOfNicks
		on: self.
	nicks removeAll.	
	nicks addAll: nickList nicks.
	announcer announce: nickList.! !

!IrkaChannel methodsFor: 'printing' stamp: 'AttilaMagyar 11/10/2012 00:03'!
printOn: aStream
	aStream nextPutAll: chanName! !

!IrkaChannel methodsFor: 'adding' stamp: 'AttilaMagyar 11/3/2012 17:26'!
removeNick: aString
	nicks remove: aString.! !

!IrkaChannel methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/26/2012 22:10'!
setChanName: aString translator: anIrkaTranslator
	chanName := aString.
	translator := anIrkaTranslator.! !

Object subclass: #IrkaIrcConnection
	instanceVariableNames: 'sockStream announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaIrcConnection class methodsFor: 'instance creation' stamp: 'AttilaMagyar 9/22/2012 18:35'!
to: hostIp port: portNumber
	^ self new connectTo: hostIp port: portNumber ! !

!IrkaIrcConnection methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 20:34'!
announcer
	^ announcer! !

!IrkaIrcConnection methodsFor: 'control' stamp: 'AttilaMagyar 10/26/2012 22:05'!
connectTo: hostIP port: portNumber
	sockStream := SocketStream 
							openConnectionToHost: hostIP 
							port: portNumber.
	sockStream noTimeout.! !

!IrkaIrcConnection methodsFor: 'control' stamp: 'AttilaMagyar 9/17/2012 20:32'!
disconnect
	sockStream close
! !

!IrkaIrcConnection methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/17/2012 20:34'!
initialize 
	super initialize.
	announcer := Announcer new.! !

!IrkaIrcConnection methodsFor: 'private' stamp: 'AttilaMagyar 10/27/2012 19:40'!
parseLine: line
	| tokens |
	line hasIrcPrefix
		ifTrue: 
			[ announcer announce: (RawLineReceived parse: line) ]
		ifFalse: 
			[ (line withoutIrcPrefix beginsWith: 'PING')
				ifTrue: 
					[ self send: (line 
										copyReplaceAll: 'PING' 
										with: 'PONG') ] ]! !

!IrkaIrcConnection methodsFor: 'private' stamp: 'AttilaMagyar 11/24/2012 22:23'!
readAndParseLinesFromSocket
	| line |	
	[ sockStream isConnected ]
		whileTrue:
			[ line := sockStream nextLine.
			self parseLine: line.
			Transcript show: line; cr ]
	! !

!IrkaIrcConnection methodsFor: 'control' stamp: 'AttilaMagyar 9/17/2012 20:32'!
send: command
	sockStream sendCommand: command! !

!IrkaIrcConnection methodsFor: 'control' stamp: 'AttilaMagyar 11/24/2012 22:27'!
startProcessing
	[ self readAndParseLinesFromSocket ]
		on: PrimitiveFailed
		do: [ Transcript show: 'IrkaIrcConnection disconnected'; cr. ]
	! !

Object subclass: #IrkaIrcTranslator
	instanceVariableNames: 'announcer destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaIrcTranslator class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/26/2012 22:00'!
toDestination: destination
	^ self new setDestination: destination.! !

!IrkaIrcTranslator methodsFor: 'accessing' stamp: 'AttilaMagyar 9/17/2012 21:08'!
announcer 
	^ announcer ! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 11/10/2012 12:42'!
cmd353: rawLineReceived
	"mynick = #chan mynick nicj1 nick2 nick3"
	| args chan nicks chanStart chanEnd |
	args := rawLineReceived args.
	chanStart := (self findSeparatorInNickList: args) + 3.
	chanEnd := args findString: ' :' startingAt: chanStart.
	chan := args copyFrom: chanStart to: chanEnd - 1.
	nicks := args copyFrom: chanEnd + 2 to: args size.
	announcer announce: (IrkaTranslatedEvent nickList: (nicks findTokens: ' ') asArray on: chan)! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 11/10/2012 12:56'!
cmd366: rawLineReceived
	":hitchcock.freenode.net 366 nick #chan :End of /NAMES list."
	| chan |
	chan := (rawLineReceived args findTokens: ' ') second.
	announcer announce: (IrkaTranslatedEvent endOfNameList: chan)! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 11/5/2012 23:51'!
cmdJOIN: rawLineReceived
	| chanName user |
	chanName := rawLineReceived args withoutIrcPrefix.
	user := IrkaUser parse: rawLineReceived sender.
	announcer announce: (IrkaTranslatedEvent 
									user: user
									joinedTo: chanName).! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 11/9/2012 22:26'!
cmdNICK: rawLineReceived
	":nick!!~ident@host.net NICK :newnick"
	| newNick user |
	newNick := rawLineReceived args withoutIrcPrefix.
	user := IrkaUser parse: rawLineReceived sender withoutIrcPrefix.
	announcer announce: (IrkaTranslatedEvent 
									user: user 									
									changedNickFrom: user nick
									to: newNick).! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 11/3/2012 17:06'!
cmdPART: rawLineReceived
	| chanName user |
	chanName := rawLineReceived args.
	user := IrkaUser parse: rawLineReceived sender.
	announcer announce: (IrkaTranslatedEvent 
									user: user
									left: chanName).! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 10/28/2012 18:25'!
cmdPRIVMSG: rawLineReceived
	"command=PRIVMSG args=#funcoder :1 2 3"
	| parts recipient msg senderUser |
	parts := rawLineReceived args findTokens: ' '.
	recipient := parts removeFirst.
	msg := (' ' join: parts) allButFirst: 1.
	senderUser := IrkaUser parse: rawLineReceived sender.
	announcer announce: (IrkaTranslatedEvent 
									message: msg 
									from: senderUser
									to: recipient).! !

!IrkaIrcTranslator methodsFor: 'parsing' stamp: 'AttilaMagyar 11/9/2012 20:20'!
cmdQUIT: rawLineReceived
	| quitMessage user |
	quitMessage := rawLineReceived args withoutIrcPrefix.
	user := IrkaUser parse: rawLineReceived sender.
	announcer announce: (IrkaTranslatedEvent 
									user: user
									quitWithMessage: quitMessage).! !

!IrkaIrcTranslator methodsFor: 'private' stamp: 'AttilaMagyar 9/26/2012 21:14'!
findSeparatorInNickList: line
	| idx |
	idx := line findString: ' = '.
	idx isZero
		ifTrue: [ idx := line findString: ' @ ' ].
	idx isZero 
		ifTrue: [ IrkaError signal: 'Invalid nicklist format ' , line ].
	^ idx! !

!IrkaIrcTranslator methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/17/2012 21:07'!
initialize 
	super initialize.
	announcer := Announcer new.! !

!IrkaIrcTranslator methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/26/2012 22:00'!
setDestination: dest
	destination := dest! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 9/26/2012 22:26'!
translateChangeNick: newNick 
	destination send: 'NICK ', newNick! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 9/26/2012 22:26'!
translateJoin: chanName
	destination send: 'JOIN ', chanName! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 9/26/2012 22:26'!
translateLeave: chanName 
	destination send: 'PART ', chanName.! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 10/26/2012 22:03'!
translateMessage: message to: target
	destination 
		send: 'PRIVMSG ', target asString, ' :', message asString.! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 10/26/2012 22:03'!
translateQuit
	destination 
		send: 'QUIT'; 
		disconnect.! !

!IrkaIrcTranslator methodsFor: 'translating irc to message' stamp: 'AttilaMagyar 10/26/2012 22:02'!
translateRaw: aRawLineReceived	
	| msg |
	msg := ('cmd', aRawLineReceived command, ':') asSymbol.
	(self respondsTo: msg) ifTrue: 
		[ self perform: msg with: aRawLineReceived ]! !

!IrkaIrcTranslator methodsFor: 'translating message to irc' stamp: 'AttilaMagyar 10/26/2012 22:03'!
translateRegisterUser: aNick
	destination 
		send: 'NICK ', aNick;
		send: 'USER ', aNick, ' Server 0 :', aNick.! !

Object subclass: #IrkaListModel
	instanceVariableNames: 'list index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:55'!
add: element
	list add: element.
	self changed: #list.! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 21:17'!
clean
	list removeAll.
	self changed: #list.! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:30'!
index
	^ index! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 11/2/2012 21:47'!
index: anInteger
	index := anInteger.
	self changed: #index.! !

!IrkaListModel methodsFor: 'initialization' stamp: 'AttilaMagyar 9/23/2012 20:33'!
initialize 
	super initialize.
	index := 0.
	list := OrderedCollection new.! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:30'!
list
	^ list! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 9/23/2012 20:32'!
menu
	^ nil! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 11/3/2012 19:01'!
remove: element
	list remove: element.
	self changed: #list.! !

!IrkaListModel methodsFor: 'accessing' stamp: 'AttilaMagyar 11/2/2012 19:18'!
size
	^ list size! !

Object subclass: #IrkaPanels
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaPanels class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/5/2012 21:29'!
horizontalPane
	^ PanelMorph new
		layoutPolicy: RowLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill;			
		cellInset: 1;
		layoutInset: 1;
		yourself! !

!IrkaPanels class methodsFor: 'instance creation' stamp: 'AttilaMagyar 11/5/2012 21:29'!
verticalPane
	^ PanelMorph new
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		cellInset: 1;
		layoutInset: 1;		
		yourself! !

Object subclass: #IrkaServer
	instanceVariableNames: 'chanMessages chanList nickLists activeChannel session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaServer methodsFor: 'private' stamp: 'AttilaMagyar 11/4/2012 20:51'!
ceaseChan: anIrkaChannel
	chanList removeChan: anIrkaChannel.
	chanMessages removeCardFrom: anIrkaChannel.
	nickLists removeCardFrom: anIrkaChannel.! !

!IrkaServer methodsFor: 'accessing' stamp: 'AttilaMagyar 11/4/2012 00:01'!
chanList
	^ chanList! !

!IrkaServer methodsFor: 'accessing' stamp: 'AttilaMagyar 11/4/2012 00:01'!
chanMessages
	^ chanMessages! !

!IrkaServer methodsFor: 'user events' stamp: 'AttilaMagyar 11/4/2012 20:22'!
chanSelected: aChanSelected
	self switchToChan: aChanSelected chan.! !

!IrkaServer methodsFor: 'irc events' stamp: 'AttilaMagyar 11/4/2012 20:35'!
clientJoinedTo: anIrkaJoined
	| newChan |
	newChan := anIrkaJoined chan.
	chanList addChan: newChan.
	self subscribeToChanEvents: newChan.
	self switchToChan: newChan.! !

!IrkaServer methodsFor: 'irc events' stamp: 'AttilaMagyar 11/4/2012 21:07'!
clientLeft: anIrkaLeft
	self ceaseChan: anIrkaLeft chan.	
	anIrkaLeft chan = activeChannel
		ifTrue: [ 
			chanList hasChan
				ifTrue: 
					[ self switchToChan: chanList firstChan ] ]	"XXX possible FE"! !

!IrkaServer methodsFor: 'commands' stamp: 'AttilaMagyar 11/9/2012 22:51'!
connectTo: hostString port: portNumber
	session := Irka host: hostString port: portNumber.
	chanList setSession: session.	
	session register: 'irkaclient'.
	session announcer on: IrkaClientJoined send: #clientJoinedTo: to: self.
	session announcer on: IrkaUserJoined send: #userJoinedTo: to: self.	
	session announcer on: IrkaUserLeft send: #userLeft: to: self.
	session announcer on: IrkaClientLeft send: #clientLeft: to: self.
	session announcer on: IrkaUserQuit send: #userQuit: to: self.
	session announcer on: IrkaUserChangedNick send: #userChangedNick: to: self.! !

!IrkaServer methodsFor: 'commands' stamp: 'AttilaMagyar 11/5/2012 22:45'!
disconnect
	session ifNotNil: [ session close ]! !

!IrkaServer methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/4/2012 20:18'!
initialize 
	super initialize.
	chanMessages := IrkaChanMessages new.
	nickLists := IrkaNickLists new.	
	chanList := IrkaChanList new.		
	chanList announcer 
		on: ChanSelected
		send: #chanSelected: 
		to: self.	! !

!IrkaServer methodsFor: 'irc events' stamp: 'AttilaMagyar 11/3/2012 23:13'!
messageReceived: anIrkaMessage
	chanMessages messageReceived: anIrkaMessage.! !

!IrkaServer methodsFor: 'user events' stamp: 'AttilaMagyar 11/4/2012 20:24'!
messageToActiveChan: aString
	activeChannel ifNil: [ ^ self ].	
	activeChannel message: aString.	
	chanMessages messageReceived: (IrkaChanMessage
			message: aString
			on: activeChannel
			fromUser: (IrkaUser parse: 'yourself!!ident@host.hu')). "TODO myhost"
! !

!IrkaServer methodsFor: 'accessing' stamp: 'AttilaMagyar 11/4/2012 00:01'!
nickLists
	^ nickLists ! !

!IrkaServer methodsFor: 'irc events' stamp: 'AttilaMagyar 11/3/2012 23:13'!
nicklistReceived: anIrkaNickList
	anIrkaNickList nicks do: 		
		[:each | 
		nickLists 
			addNick: each 
			toChan: anIrkaNickList chan ].! !

!IrkaServer methodsFor: 'private' stamp: 'AttilaMagyar 11/4/2012 20:33'!
subscribeToChanEvents: anIrkaChannel 
	anIrkaChannel  announcer 
		on: IrkaChanMessage 
		send: #messageReceived: 
		to: self.
	anIrkaChannel announcer 
		on: IrkaChanNickList 
		send: #nicklistReceived: 
		to: self! !

!IrkaServer methodsFor: 'private' stamp: 'AttilaMagyar 11/4/2012 21:34'!
switchToChan: anIrkaChannel
	activeChannel := anIrkaChannel.
	nickLists switchToChan: activeChannel.
	chanMessages switchToChan: activeChannel.
	chanList selectChan: anIrkaChannel.
! !

!IrkaServer methodsFor: 'irc events' stamp: 'AttilaMagyar 11/10/2012 00:08'!
userChangedNick: anIrkaUserChangedNick 
	anIrkaUserChangedNick affectedChans do:
		[:each |
		nickLists 
			renameNick: anIrkaUserChangedNick oldNick
			to: anIrkaUserChangedNick newNick
			atChan: each.
		chanMessages 
			systemNotification: '>>', 
				anIrkaUserChangedNick oldNick, ' changed nick to ', 
				anIrkaUserChangedNick newNick
			onChan: each ]! !

!IrkaServer methodsFor: 'irc events' stamp: 'AttilaMagyar 11/4/2012 20:43'!
userJoinedTo: anIrkaJoined
	chanMessages 
		systemNotification: '>>', anIrkaJoined user nick, ' has joined to ', anIrkaJoined chan printString
		onChan: anIrkaJoined chan.			
	nickLists 
		addNick: anIrkaJoined user nick 
		toChan: anIrkaJoined chan! !

!IrkaServer methodsFor: 'irc events' stamp: 'AttilaMagyar 11/4/2012 20:42'!
userLeft: anIrkaLeft
	chanMessages 
		systemNotification: '>>', anIrkaLeft user nick, ' has left ', anIrkaLeft chan printString
		onChan: anIrkaLeft chan.
	nickLists 
		removeNick: anIrkaLeft user nick 
		fromChan: anIrkaLeft chan.	! !

!IrkaServer methodsFor: 'irc events' stamp: 'AttilaMagyar 11/9/2012 21:07'!
userQuit: anIrkaQuit
	anIrkaQuit affectedChans do:
		[:each |
		nickLists 
			removeNick: anIrkaQuit user nick 
			fromChan: each.
		chanMessages 
			systemNotification: '>>', anIrkaQuit user nick, ' quit ', anIrkaQuit quitMessage
			onChan: each ]! !

Object subclass: #IrkaSession
	instanceVariableNames: 'translator channels announcer mynick collectedNicks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaSession methodsFor: 'accessing' stamp: 'AttilaMagyar 9/22/2012 19:31'!
announcer 
	^ announcer ! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 9/23/2012 18:50'!
changeNick: newNick 
	translator translateChangeNick: newNick.! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 9/26/2012 19:30'!
close
	translator translateQuit.! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 11/10/2012 14:36'!
endOfNameList: anIrkaTranslatedEndOfNameList 
	| chan |
	chan := channels 
				at: anIrkaTranslatedEndOfNameList chanName 
				ifAbsent: 
					[ Error signal: 'Chan not found ', 
						anIrkaTranslatedEndOfNameList chanName ].
	chan nicks: collectedNicks.
	collectedNicks removeAll.! !

!IrkaSession methodsFor: 'private' stamp: 'AttilaMagyar 11/3/2012 17:17'!
getOrCreateChan: chanName
	^ channels 
		at: chanName 
		ifAbsentPut:
			[ IrkaChannel 
				named: chanName 
				translator: translator ]! !

!IrkaSession methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/10/2012 13:19'!
initialize 
	super initialize.
	channels := Dictionary new.
	announcer := Announcer new.
	collectedNicks := OrderedCollection new.! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 10/27/2012 20:14'!
joinChan: chanName 
	translator translateJoin: chanName asString.! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 11/3/2012 18:10'!
joined: anIrkaTranslatedJoin
	| chan chanName |
	chanName := anIrkaTranslatedJoin chanName.
	chan := self getOrCreateChan: chanName.
	chan addNick: anIrkaTranslatedJoin user nick.
	anIrkaTranslatedJoin user nick = mynick
		ifTrue: 
			[ announcer announce: (IrkaClientJoined 
				user: anIrkaTranslatedJoin user 
				to: chan) ]
		ifFalse:
			[ announcer announce: (IrkaUserJoined 
				user: anIrkaTranslatedJoin user 
				to: chan) ]! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 11/3/2012 19:41'!
leaveChan: chanName 
	translator translateLeave: chanName asString.! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 11/3/2012 18:21'!
left: anIrkaTranslatedLeave
	| chan |
	chan := channels at: anIrkaTranslatedLeave chanName.
	chan removeNick: anIrkaTranslatedLeave user nick.
	
	anIrkaTranslatedLeave user nick = mynick
		ifTrue: 
			[ channels removeKey: anIrkaTranslatedLeave chanName.
			announcer announce: (IrkaClientLeft 
				user: anIrkaTranslatedLeave user
				from: chan) ]
		ifFalse:
			[ announcer announce: (IrkaUserLeft 
				user: anIrkaTranslatedLeave user
				from: chan) ].! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 11/10/2012 16:18'!
messageReceived: anIrkaTranslatedMessage
	| chan recipient message sender |
	sender := anIrkaTranslatedMessage senderUser.
	recipient := anIrkaTranslatedMessage recipientName.
	message := anIrkaTranslatedMessage message.
	
	recipient = mynick
		ifTrue: 
			[ announcer announce: (IrkaPrivMessage 
				message: message 
				fromUser: sender
				session: self) ]
		ifFalse:
			[ chan := channels 
				at: recipient 
				ifAbsent: [ Error signal: 'Chan not found ', recipient ].
			chan 
				message: message 
				from: sender ]! !

!IrkaSession methodsFor: 'accessing' stamp: 'AttilaMagyar 10/27/2012 20:05'!
nick
	"TODO try to remove me"
	^ mynick! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 11/10/2012 00:04'!
nickChanged: anIrkaTranslatedNickChange
	anIrkaTranslatedNickChange oldNick = mynick
		ifTrue: [ mynick := anIrkaTranslatedNickChange newNick ]
		ifFalse: [ self renameNickInChansAndSendNotification: anIrkaTranslatedNickChange ]! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 11/10/2012 16:17'!
nickListReceived: anIrkaTranslatedNameList
	collectedNicks addAll: anIrkaTranslatedNameList nicks.! !

!IrkaSession methodsFor: 'translated events' stamp: 'AttilaMagyar 11/9/2012 22:57'!
quit: anIrkaTranslatedQuit
	| affectedChans |
	affectedChans := self removeNickIfPresent: anIrkaTranslatedQuit user nick.
	announcer announce:
		(IrkaUserQuit
			user: anIrkaTranslatedQuit user
			withQuitMessage: anIrkaTranslatedQuit quitMessage
			affectedChans: affectedChans)! !

!IrkaSession methodsFor: 'commands' stamp: 'AttilaMagyar 10/27/2012 00:05'!
register: aNick
	mynick := aNick.
	translator translateRegisterUser: aNick.! !

!IrkaSession methodsFor: 'private' stamp: 'AttilaMagyar 11/9/2012 22:57'!
removeNickIfPresent: nick
	| affectedChans |
	affectedChans := channels values select: [ :each | each hasNick: nick].
	affectedChans do: [ :each | each removeNick: nick ].
	^ affectedChans! !

!IrkaSession methodsFor: 'private' stamp: 'AttilaMagyar 11/10/2012 00:04'!
renameNickInChansAndSendNotification: anIrkaTranslatedNickChange
	| affectedChans |
	affectedChans := self removeNickIfPresent: anIrkaTranslatedNickChange oldNick.
	affectedChans do: [ :each | each addNick: anIrkaTranslatedNickChange newNick ].
	announcer announce:
			(IrkaUserChangedNick
				user: anIrkaTranslatedNickChange user
				from: anIrkaTranslatedNickChange oldNick
				to: anIrkaTranslatedNickChange newNick
				affectedChans: affectedChans)! !

!IrkaSession methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/15/2012 22:40'!
translator: anIrkaTranslator
	translator := anIrkaTranslator.! !

Object subclass: #IrkaUser
	instanceVariableNames: 'nick host ident'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-Core'!

!IrkaUser class methodsFor: 'instance creation' stamp: 'AttilaMagyar 9/25/2012 16:03'!
parse: aString
	^ self new parse: aString ! !

!IrkaUser methodsFor: 'comparing' stamp: 'AttilaMagyar 9/25/2012 17:20'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ nick = anObject nick and: [ host = anObject host and: [ ident = anObject ident ] ]! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 16:52'!
findIdentHostSeparator: hostMask
	| idx |
	idx := hostMask findString: '@' startingAt: (self findNickIdentSeparator: hostMask).
	idx isZero
		ifTrue: [ IrkaError signal: 'Invalid host format ' , hostMask ].
	^ idx	! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 16:46'!
findNickIdentSeparator: hostMask
	| idx |
	idx := hostMask findString: '!!'.
	idx isZero
		ifTrue: [ IrkaError signal: 'Invalid host format ' , hostMask ].
	^ idx! !

!IrkaUser methodsFor: 'comparing' stamp: 'AttilaMagyar 9/25/2012 17:20'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ nick hash bitXor: (host hash bitXor: ident hash)! !

!IrkaUser methodsFor: 'accessing' stamp: 'AttilaMagyar 9/25/2012 16:06'!
host
	^ host! !

!IrkaUser methodsFor: 'accessing' stamp: 'AttilaMagyar 9/25/2012 16:16'!
ident
	^ ident! !

!IrkaUser methodsFor: 'accessing' stamp: 'AttilaMagyar 9/25/2012 16:05'!
nick
	^ nick! !

!IrkaUser methodsFor: 'initialize-release' stamp: 'AttilaMagyar 9/25/2012 16:42'!
parse: aString
	"parse hostmasks like :nick!!~ident@host.hu"
	| hostMask |
	hostMask := aString withoutIrcPrefix.
	nick := self parseNick: hostMask.
	ident := self parseIdent: hostMask.
	host := self parseHost: hostMask.! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 17:12'!
parseHost: hostMask
	| hostStart |
	hostStart := (self findIdentHostSeparator: hostMask) +1.
	^ hostMask copyFrom: hostStart to: hostMask size.! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 17:13'!
parseIdent: hostMask
	| identStart identEnd |
	identStart := (self findNickIdentSeparator: hostMask) + 1.
	identEnd := (self findIdentHostSeparator: hostMask) - 1.
	^ self trimTilde: (hostMask copyFrom: identStart to: identEnd)! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 16:48'!
parseNick: hostMask
	^ hostMask copyFrom: 1 to: (self findNickIdentSeparator: hostMask) - 1! !

!IrkaUser methodsFor: 'printing' stamp: 'AttilaMagyar 9/26/2012 23:07'!
printOn: aStream
	^ aStream nextPutAll: nick, '!!', ident, '@', host.! !

!IrkaUser methodsFor: 'private' stamp: 'AttilaMagyar 9/25/2012 17:13'!
trimTilde: fullIdent
	^ (fullIdent beginsWith: '~')
		ifTrue: [ fullIdent allButFirst: 1 ]
		ifFalse: [ fullIdent ]! !

PluggableTextMorph subclass: #IrkaTypingBox
	instanceVariableNames: 'text listener enterSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Irka-GUI'!

!IrkaTypingBox class methodsFor: 'instance creation' stamp: 'AttilaMagyar 10/28/2012 19:49'!
on: listener entered: selector
	^ self new
		setListener: listener
		selector: selector! !

!IrkaTypingBox methodsFor: 'initialize-release' stamp: 'AttilaMagyar 11/5/2012 21:58'!
initialize 
	super initialize.
	self on: self
		text: #typedMessage
		accept: #typedMessage:
		readSelection: nil
		menu: nil.										
	self
		minHeight: 28;
		vResizing: #shrinkWrap;
		hideVScrollBarIndefinitely: true;
		hResizing: #spaceFill;
		acceptOnCR: true.	! !

!IrkaTypingBox methodsFor: 'initialize-release' stamp: 'AttilaMagyar 10/28/2012 19:50'!
setListener: listenerObject selector: selectorSymbol
	listener := listenerObject.
	enterSelector := selectorSymbol.! !

!IrkaTypingBox methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 19:43'!
typedMessage
	^ text! !

!IrkaTypingBox methodsFor: 'private' stamp: 'AttilaMagyar 10/28/2012 20:02'!
typedMessage: aString	
	text := aString.
	listener 
		perform: enterSelector 
		with: text.
	self setText: ''.! !
